import fileinput
import glob

def extractParameter( parameterName, parameterPosition, dataString ):
    parPos = dataString.find( parameterName )
    if parPos == -1:
        ret = '-'
    else:
        left = dataString.find( '(', parPos )
        right = dataString.find( ')', parPos )
        data = dataString[left+1:right].split( ',' )
        ret = data[parameterPosition]
    return ret


print ('10') # number of attributes, 8 originally but 2 inactive for id here
print ('0 1 1')
print ('0 1 1')
for _ in range(8):
    print ('1 1 1')
    
idcounter = 1;    
for line in fileinput.input( glob.glob('det/*.det') ):
    name = fileinput.filename()
    pos=name.find('.det')
    #print name
    if ( name[pos-2:pos] == '00' ):
        #print 'skips: ', name
        fileinput.nextfile() # we have a phi angle image thingie
        #print( 'skipped: ' + name )
    elif ( name[pos-5:pos-3] == '22' ):
    #elif ( name[pos-2:pos] == '01' ): # only do images with phi angle '01'
    #else: #do all images
        if ( 'ext' in line ): # only use nodes with external countours
        #if ( line.startswith( '[' ) ):
            #we have a graph
            idPos=line.find('id=c')
            
            nodeChar = line[ 1:line.find('[',1) ]
            #id is node character + idnumber from .det file
            id = line[ idPos+4 : line.find(';') ] 
            
            print(  str(idcounter) + ' ' + id + ' ' + str(ord(nodeChar.upper())-ord('A')) + ' ' +
                    extractParameter( 'aa', 0, line ) + ' ' +
                    extractParameter( 'cr', 0, line ) + ' ' +
                    extractParameter( 'cr', 1, line ) + ' ' +
                    extractParameter( 'cr', 2, line ) + ' ' +
                    extractParameter( 'mm', 0, line ) + ' ' +
                    extractParameter( 'mm', 1, line ) + ' ' +
                    extractParameter( 'mm', 2, line ) + ' ' +
                    extractParameter( 'mm', 3, line ) 
                    )
                    
            idcounter+=1        
        
print('0')        
            