import Image
import ImageDraw

colors = [(235,235,255), (149, 149, 149), (182, 182, 182), (185, 185, 185), (134, 134, 134), (170, 170, 170), (161, 161, 161), (146, 146, 146), (176, 176, 176), (167, 167, 167), (137, 137, 137), (155, 155, 155), (179, 179, 179), (131, 131, 131), (128, 128, 128), (140, 140, 140), (143, 143, 143), (158, 158, 158), (152, 152, 152), (164, 164, 164), (173, 173, 173)]

def createimg(fileid,nodeid):
    file = open('C:/Users/Ole/masters/clusterdata/clusterdata/' + fileid + '.det')
    
    #find cg
    intcount = 0
    
    for line in file:
        if 'int' in line:
            intcount += 1
        
        if line.startswith('['+nodeid):
            # we have found our node
            
            
            
            cgpos = line.find('cg(')
            cgendpos = line.find(')',cgpos)
            cg = line[cgpos+3:cgendpos].split(',')
            
            #crpos=line.find('cr(')
            #crendpos=line.find(')',crpos)
            #cr = line[crpos+3:crendpos].split(',')
            
            #print 'cg: ' + str(cg)
            
            
            file2 = open('C:/Users/ole/masters/clusterdata/clusterdata/' + fileid + '.pic', 'rb')
            rawdata = file2.read()
            file2.close()
            
            maxintensity = ord( max( rawdata ) )
            
            #j = 0
            segmentnodelinkarray = []
            for i in range( maxintensity+1 ):
                if chr(i) in rawdata:
                    #print 'found one!: ' + str(i)
                    segmentnodelinkarray.append(i)
                    #j += 1
            
            #print rawdata
            #print maxintensity
            #print segmentnodelinkarray
            
            im = Image.fromstring('RGBA', (128,128), rawdata, 'raw', 'RGBA', 0, 1 )
            pixels = im.load()

            #valatcg = max( pixels[ int(cg[1]), int(cg[0]) ] )
            #valatcg = ord(nodeid)-64 # hack to use segment number instead of cg, did not work!
            #print 'aa:' + str(ord(nodeid)-64-intcount) + ' : ' + nodeid + ' fileid: ' + fileid + ' intcount: ' + str(intcount)
            
            if 'int' in line:
                valatcg = -1
            else:
                valatcg = segmentnodelinkarray[ord(nodeid)-64-intcount]
            
            for i in range(im.size[0]):
                for j in range(im.size[1]):
                    #val = max( pixels[ i, j ] )
                    #if (val != 0):
                    #    val = int(float(val)/float(maxintensity)*255.0)
                    #if val != 0:
                    #    print 'val: ' + str(val)
                        #pixels[ i, j ] = ((val*93)%255,255-((val*93)%255),(val*734)%128+127,val)
                    maxval = max( pixels[ i, j ] )
                    if maxval == valatcg:
                        pixels[ i, j ] = (255, 0, 0)
                    else:
                        pixels[ i, j ] = colors[ maxval ]
                    #pixels[ i, j ] = colors[ maxval ]
            #im.rotate(90).save('1001.png','png')
            filenamenpath = 'imgfiles/' + fileid + nodeid + '.png'
            #draw = ImageDraw.Draw(im)
            #draw.ellipse( (int(cg[1])-3, int(cg[0])-3, int(cg[1])+3, int(cg[0])+3), fill=(255,255,255) )
            #draw.ellipse( (int(cg[1])-2, int(cg[0])-2, int(cg[1])+2, int(cg[0])+2), fill=(255,0,0) )
            im.rotate(90).save(filenamenpath)
            
            file.close()
            return filenamenpath
    
    file.close()       
    return -1
    
    
file = open('rep1trans2.txt', 'r')

counter = 1
for line in file:
    

    if line.startswith('Class'):
        pass
    else:
        linesplit = line.split()
        createimg( linesplit[0], linesplit[1] )

    if counter % 10 == 0:
        print counter
    counter += 1
     
file.close()
