import Image
import ImageDraw

colors = [(235,235,255), (149, 149, 149), (182, 182, 182), (185, 185, 185), (134, 134, 134), (170, 170, 170), (161, 161, 161), (146, 146, 146), (176, 176, 176), (167, 167, 167), (137, 137, 137), (155, 155, 155), (179, 179, 179), (131, 131, 131), (128, 128, 128), (140, 140, 140), (143, 143, 143), (158, 158, 158), (152, 152, 152), (164, 164, 164), (173, 173, 173)]

#memo = None # to remember to intcounts

#input like: '1001', ['A','B']
def createtripimg(fileid,nodeids):
            
    #first find mapping from nodes (A,B....) -> to segment number in .pic (1,2,3,4,5...)
    #every int node is skipped in the pic file so if A(ext), B(int), C(ext) then A->1,C->2,...
    #this is the hypothesis atm but it is not fully true it seems
    # numbers in .pic are not consecutive, ie: 1,2,5,6. why theese gaps i dont know, but if
    # A(ext), B(int), C(ext), D(ext) and .pic has [1,2,5], then a->1, c->, d->5
    
    
    numbermapping = dict()
    #numbercounter = 1
    #if memo[int(fileid)] == None:
    #intcount = 0
    
    file = open('C:/Users/ole/masters/clusterdata/clusterdata/' + fileid + '.det' )
    
    for line in file:
        #if 'int' in line:
        #    intcount += 1
        if line.startswith('['): # we have a node
            if 'ext' in line:
                numbermapping[ line[1] ] = len(numbermapping)+1
                # #numbercounter += 1
    file.close()
    #    memo[int(fileid)] = intcount
    #else:
    #    intcount = memo[int(fileid)]
    #now build the image
    
    file2 = open('C:/Users/ole/masters/clusterdata/clusterdata/' + fileid + '.pic', 'rb')
    rawdata = file2.read()
    file2.close()
    
    maxintensity = ord(max(rawdata))
    numbermappingarray = []
    for i in range(maxintensity+1):
        if chr(i) in rawdata:
            numbermappingarray.append(i)
    
    
    im = Image.fromstring('RGBA', (128,128), rawdata, 'raw', 'RGBA', 0, 1 )
    pixels = im.load()

    for i in range(im.size[0]):
        for j in range(im.size[1]):
            maxval = max( pixels[ i, j ] )
            nummaps = [ numbermappingarray[ numbermapping[ nodeids[0] ] ], numbermappingarray[ numbermapping[ nodeids[1] ] ] ]
            #nummaps = [ numbermappingarray[ord(nodeids[0])-64-intcount], numbermappingarray[ord(nodeids[1])-64-intcount] ]
            if maxval == nummaps[0]:
                pixels[ i, j ] = (255, 0, 0)
            elif maxval == nummaps[1]:
                pixels[ i, j ] = (0, 0, 255)
            else:
                pixels[ i, j ] = colors[ maxval ]
    
    filenamenpath = 'imgfiles/trip/' + fileid + nodeids[0] + '_' + nodeids[1] + '.png'
    im.rotate(90).save(filenamenpath)
    
    return filenamenpath
    
    
#createtripimg('1001',['E','D'] )
#memo = [None] * 30000
with open('alltrip.raw') as f:
    it = iter(f)
    
    for _ in range( int( it.next() ) ):
        it.next()
    
    
    for line in it:
        #print line
        if line == '0':
            break
        else:
            linesplit = line.split()
            createtripimg( linesplit[1], map( lambda x: chr(int(x)+ord('A')), linesplit[2:4] ) )
            next(it)
            next(it)
            
            print linesplit[0]
            
            
    #print it.next()

     
#line = f.readline()
#for i in range( int(line) ):
#    next(f)


