#pragma once

#include "SomVector.h"

class SomNode
{
public:
	SomNode( double *position, int dimensions);

	double distanceSquared(SomNode &other);
	double distance(SomNode &other) { return sqrt(distanceSquared(other));}
	
	void setVector(SomVector *vec) { vecPtr = vec; }
	SomVector *getSomVector() { return vecPtr; }
	double getPos(int dim){ return position[dim]; }

	void print();

	~SomNode(void);


private:
	double *position;
	int dimensions;
	SomVector *vecPtr;
};

