#include "stdafx.h"
#include "VariableCircular.h"

#include <cmath>
#include <algorithm>

#include <iostream>

VariableCircular::VariableCircular( double period )
{
	this->period = period;
}
VariableCircular::VariableCircular( double value, double period )
{
	this->period = period;
	setValue(value);
}
double VariableCircular::difference(double other)
{
	if ( getValue() < other )
	{
		double option1 = other - getValue();
		double option2 = 0 - getValue() - ( period - other );
		if ( abs(option1)<abs(option2) )
			return option1;
		else
			return option2;
	}
	else
	{
		double option1 = getValue() - other;
		double option2 = period - getValue() + other;
		if ( abs(option1)<abs(option2) )
			return option1;
		else
			return option2;
	}
}
double VariableCircular::normalize(double val)
{
	return val - period*floor(val/period);
}


void VariableCircular::setValue(double val)
{
	//if ( val >= 0 && val < period )
	//	DataItem::setValue(val);
	
	VariableContinuous::setValue( normalize( val ) );
}
	


VariableCircular::~VariableCircular(void)
{
}
