#pragma once
#include "VariableContinuous.h"
class VariableCircular :
	public VariableContinuous
{
public:
	VariableCircular( double period );
	VariableCircular( double value, double period );
	
	virtual double difference(double other);
	void setValue(double val);
	double normalize( double val);
	
	virtual VariableContinuous *clone(){ return new VariableCircular(getValue(),period); }

	~VariableCircular( void );
private:
	double period;
};

