#C:\Users\Ole\masters\clusterdata\clusterdata

import fileinput
import glob

def extractParameter( parameterName, parameterPosition, dataString ):
    parPos = dataString.find( parameterName )
    if parPos == -1:
        ret = '-'
    else:
        left = dataString.find( '(', parPos )
        right = dataString.find( ')', parPos )
        data = dataString[left+1:right].split( ',' )
        ret = data[parameterPosition]
    return ret

def splitsgm( sgmstring ):
    ret = []
    curstring = ''
    counter = 0
    for char in sgmstring:
        curstring += char
        
        if char == '[':
            counter += 1
        elif char == ']':
            counter -= 1
        
        if counter == 0: # time to break string
            ret.append(curstring)
            curstring = ''
    
    return ret        
        

print ('21') # number of attributes, 8  for each thing,3 id, 2 for edge
print ('0 1 1') #idnumber
print ('0 1 1') #nodechar1
print ('0 1 1') #nodechar2

for _ in range(8): #8 attributes for each thing
    print ('1 1 1')

#print ('1 1 1') #edge direction
print ('1 4 0 1') #edge direction
print ('1 2 4') #nothng/inside/outside/superimposed
    
for _ in range(8): #8 attributes for each thing
    print ('1 1 1')

    
idcounter = 1;    
for line in fileinput.input( glob.glob('C:/Users/Ole/masters/clusterdata/clusterdata/*.sgm') ):
    name = fileinput.filename()
    pos=name.find('.sgm')
    #print name
    if ( name[pos-2:pos] == '00' ):
        #print 'skips: ', name
        fileinput.nextfile() # we have a phi angle image thingie
        #print( 'skipped: ' + name )
    # elif ( name[pos-5:pos-3] == '22' ):
    else:
        #print name
        #fileinput.nextfile()
        #continue
        #if not 'int' in line: # only use nodes with external countours
        if line.startswith('[') and not 'int' in line: #this is a node-arc-node triplet
            splittedline = splitsgm(line)
            
            idpos = splittedline[0].find('id=c')
            id = line[ idpos+4 : line.find(';') ] 
            
            nodechar1 = splittedline[0][ 1:splittedline[0].find('[',1) ]
            nodechar2 = splittedline[2][ 1:splittedline[2].find('[',1) ]
            
            edgeinfo = splittedline[1][ 2:splittedline[1].find(']') ]
            # 0 = nothing, 1=superimposed('s') 2=inside('i') 3=outside('o')
            if 's' in edgeinfo:
                insideoutside = 1
                edgeinfo = edgeinfo.replace('s','')
            elif 'i' in edgeinfo:
                insideoutside = 2
                edgeinfo = edgeinfo.replace('i','')
            elif 'o' in edgeinfo:
                insideoutside = 3
                edgeinfo = edgeinfo.replace('o','')
            else:
                insideoutside = 4
                
            edgedir = edgeinfo    
            if len(edgedir)>1:
                print 'problem!!: edgedir: ', edgedir, insideoutside
            
            # insideoutside = 0 
            # if len(edgedir) == 2:
                # if edgedir[1] == 's':
                    
                # elif edgedir[1] == 'i':
                    # insideoutside = 2
                # elif edgedir[1] == 'o':
                    # insideoutside = 3
                # else:
                    # print 'unknown insideoutside!!: ', splittedline[1]
                
                # edgedir = edgedir[0]
            
            #print id, nodechar1, nodechar2, edgedir, insideoutside
            print str(idcounter), id, str(ord(nodechar1)-ord('A')), str(ord(nodechar2)-ord('A')), extractParameter( 'aa', 0, splittedline[0] ), extractParameter( 'cr', 0, splittedline[0] ), extractParameter( 'cr', 1, splittedline[0] ), extractParameter( 'cr', 2, splittedline[0] ), extractParameter( 'mm', 0, splittedline[0] ), extractParameter( 'mm', 1, splittedline[0] ), extractParameter( 'mm', 2, splittedline[0] ), extractParameter( 'mm', 3, splittedline[0] )
            print float(int(edgedir,16))/16*360, insideoutside
            print extractParameter( 'aa', 0, splittedline[2] ), extractParameter( 'cr', 0, splittedline[2] ), extractParameter( 'cr', 1, splittedline[2] ), extractParameter( 'cr', 2, splittedline[2] ), extractParameter( 'mm', 0, splittedline[2] ), extractParameter( 'mm', 1, splittedline[2] ), extractParameter( 'mm', 2, splittedline[2] ), extractParameter( 'mm', 3, splittedline[2] )
                
            idcounter += 1
            
    #elif ( name[pos-2:pos] == '01' ): # only do images with phi angle '01'
    #else: #do all images
        # if ( 'ext' in line ): # only use nodes with external countours
        # #if ( line.startswith( '[' ) ):
            # #we have a graph
            # idPos=line.find('id=c')
            
            # nodeChar = line[ 1:line.find('[',1) ]
            # #id is node character + idnumber from .det file
            # id = line[ idPos+4 : line.find(';') ] 
            
            # print(  str(idcounter) + ' ' + id + ' ' + str(ord(nodeChar.upper())-ord('A')) + ' ' +
                    # extractParameter( 'aa', 0, line ) + ' ' +
                    # extractParameter( 'cr', 0, line ) + ' ' +
                    # extractParameter( 'cr', 1, line ) + ' ' +
                    # extractParameter( 'cr', 2, line ) + ' ' +
                    # extractParameter( 'mm', 0, line ) + ' ' +
                    # extractParameter( 'mm', 1, line ) + ' ' +
                    # extractParameter( 'mm', 2, line ) + ' ' +
                    # extractParameter( 'mm', 3, line ) 
                    # )
                    
            # idcounter+=1        
        
print('0')        
            