#include "stdafx.h"
#include "SimpleNBFunc.h"
#include <cmath>

SimpleNBFunc::SimpleNBFunc(double start, double step)
{
	this->start = start;
	this->step = step;
}

bool SimpleNBFunc::areNeighboors(int x, int y, int x2, int y2, int time)
{
	return (x-x2)*(x-x2)+(y-y2)*(y-y2) <= (start + step * time) * (start + step * time);
}
double SimpleNBFunc::nbSizeSquared(int time)
{
	return (start + step * time) * (start + step * time);
}


int SimpleNBFunc::nbMaxSize(int run)
{
	return ceil(start + step * run);
}
SimpleNBFunc::~SimpleNBFunc(void)
{
}
