#include "stdafx.h"
#include "SomNode.h"
#include <iomanip>
#include <iostream>

SomNode::SomNode( double *position, int dimensions)
{
	this->vecPtr = NULL;
	this->position = new double[dimensions];
	memcpy(this->position,position,sizeof(double)*dimensions);
	this->dimensions = dimensions;
}

double SomNode::distanceSquared(SomNode &other)
{
	double sum = 0;
	for ( int i = 0; i < dimensions; ++i )
		sum += (position[i]-other.position[i]) * (position[i]-other.position[i]);
	return sum;
}

void SomNode::print()
{
	std::cout << "SomNode( ";
	for ( int i = 0; i < dimensions-1; ++i )
		std::cout <<  std::setprecision(2) << std::fixed << position[i] << ", ";
	std::cout << position[dimensions-1] << " ) ";
	//vecPtr->print();
}

SomNode::~SomNode(void)
{
	delete [] position;
	if ( vecPtr != NULL )
		delete vecPtr;
}
