#pragma once
#include <cmath>

class VariableContinuous
{
public:
	
	VariableContinuous(void);
	VariableContinuous(double value)
	{ setValue(value); }
	
	virtual double difference(VariableContinuous &other){ return difference(other.getValue()); }
	virtual double distance(VariableContinuous &other){ return distance(other.getValue()); }

	virtual double difference(double other);
	virtual double distance(double other) { return abs(difference(other)); }
	double getValue() { return val; }
	virtual void setValue( double value ) { val = value; }

	virtual VariableContinuous *clone(){ return new VariableContinuous(val); }

	~VariableContinuous(void);

private:
	double val;
};

